//
// FilterIO
//

// $Id: FilterIO.cxx,v 1.1 2001/09/28 23:11:55 jzweizig Exp $
// $Log: FilterIO.cxx,v $
// Revision 1.1  2001/09/28 23:11:55  jzweizig
// Original version
//
// Revision 1.1  1999/10/18 17:29:36  jzweizig
// New filter I/O container and associated classes
//

#include "FilterIO.hh"

#include <stdexcept>
#include <string>
#include <map>

#include "Key.hh"
#include "KeyChain.hh"
#include "TSeries.hh"

FilterIO::~FilterIO(void) {}

// For assignment
TSeries& FilterIO::operator[] (const Key& key) 
  throw (std::invalid_argument)
{
  return iomap[key];
}

void FilterIO::erase(const Key& key)
  throw (std::invalid_argument)
{
  iomap.erase(key);
}

void FilterIO::clear(void) 
{
  iomap.clear();
}

// Inquiries

bool FilterIO::isFull(void) const
{
  return iomap.size() == chain.size();
}

bool FilterIO::isEmpty(void) const
{
  return iomap.empty();
}

KeyChain
FilterIO::keyChain(void) const 
{
  return chain;
}

FilterIO::FilterIO(const KeyChain& c) : chain(c) {};

