/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "fSeries/ASD.hh"
#include "fSeries/PSD.hh"
#include "DVecType.hh"
#include <cmath>

using namespace containers;

//======================================  ASD default constructor
ASD::ASD(void) {
}

//======================================  ASD data constructor
ASD::ASD(const PSD& fs) {
    if (empty()) return;
    size_type N = size();
    if (refDVect().D_data() ) {
	static_cast<fSeries&>(*this) = fs;
	double* p = dynamic_cast<DVectD&>(refDVect()).refTData();
	for (size_type i=0; i<N; ++i) p[i] = sqrt(p[i]);
    } else if (refDVect().F_data() ) {
	static_cast<fSeries&>(*this) = fs;
	float* p = dynamic_cast<DVectF&>(refDVect()).refTData();
	for (size_type i=0; i<N; ++i) p[i] = sqrt(p[i]);
    } else {
	DVectD dv(fs.refDVect());
	double* p = dv.refTData();
	for (size_type i=0; i<N; ++i) p[i] = sqrt(p[i]);
	setData(getLowFreq(), getFStep(), dv);
    }
}

//======================================  ASD destructor
ASD::~ASD(void) {
}


//======================================  Clone ASD
ASD* 
ASD::clone(void) const {
    return new ASD(*this);
}
